/* Generated by wayland-scanner 1.20.0 */

#ifndef WEBOS_INPUT_MANAGER_SERVER_PROTOCOL_H
#define WEBOS_INPUT_MANAGER_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_webos_input_manager The webos_input_manager protocol
 * @section page_ifaces_webos_input_manager Interfaces
 * - @subpage page_iface_wl_webos_input_manager - get additional input interface
 * - @subpage page_iface_wl_webos_seat - interface for additional input data
 * - @subpage page_iface_wl_webos_gyroscope - interface for gyroscope device
 * - @subpage page_iface_wl_webos_accelerometer - interface for accelerometer device
 * @section page_copyright_webos_input_manager Copyright
 * <pre>
 *
 * Copyright (c) 2014-2020 LG Electronics, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 * </pre>
 */
struct wl_seat;
struct wl_webos_accelerometer;
struct wl_webos_gyroscope;
struct wl_webos_input_manager;
struct wl_webos_seat;

#ifndef WL_WEBOS_INPUT_MANAGER_INTERFACE
#define WL_WEBOS_INPUT_MANAGER_INTERFACE
/**
 * @page page_iface_wl_webos_input_manager wl_webos_input_manager
 * @section page_iface_wl_webos_input_manager_desc Description
 *
 * wl_webos_seat has more information than wl_seat. User can get it using
 * get_webos_seat(seat).
 * @section page_iface_wl_webos_input_manager_api API
 * See @ref iface_wl_webos_input_manager.
 */
/**
 * @defgroup iface_wl_webos_input_manager The wl_webos_input_manager interface
 *
 * wl_webos_seat has more information than wl_seat. User can get it using
 * get_webos_seat(seat).
 */
extern const struct wl_interface wl_webos_input_manager_interface;
#endif
#ifndef WL_WEBOS_SEAT_INTERFACE
#define WL_WEBOS_SEAT_INTERFACE
/**
 * @page page_iface_wl_webos_seat wl_webos_seat
 * @section page_iface_wl_webos_seat_desc Description
 *
 * This is a webOS extension for additional input data such as gyroscope or
 * accelerometer. If the seat has additional input data, user can request it
 * using get_*.
 * @section page_iface_wl_webos_seat_api API
 * See @ref iface_wl_webos_seat.
 */
/**
 * @defgroup iface_wl_webos_seat The wl_webos_seat interface
 *
 * This is a webOS extension for additional input data such as gyroscope or
 * accelerometer. If the seat has additional input data, user can request it
 * using get_*.
 */
extern const struct wl_interface wl_webos_seat_interface;
#endif
#ifndef WL_WEBOS_GYROSCOPE_INTERFACE
#define WL_WEBOS_GYROSCOPE_INTERFACE
/**
 * @page page_iface_wl_webos_gyroscope wl_webos_gyroscope
 * @section page_iface_wl_webos_gyroscope_desc Description
 *
 * This is an interface for gyroscope device.
 * @section page_iface_wl_webos_gyroscope_api API
 * See @ref iface_wl_webos_gyroscope.
 */
/**
 * @defgroup iface_wl_webos_gyroscope The wl_webos_gyroscope interface
 *
 * This is an interface for gyroscope device.
 */
extern const struct wl_interface wl_webos_gyroscope_interface;
#endif
#ifndef WL_WEBOS_ACCELEROMETER_INTERFACE
#define WL_WEBOS_ACCELEROMETER_INTERFACE
/**
 * @page page_iface_wl_webos_accelerometer wl_webos_accelerometer
 * @section page_iface_wl_webos_accelerometer_desc Description
 *
 * This is an interface for accelerometer device.
 * @section page_iface_wl_webos_accelerometer_api API
 * See @ref iface_wl_webos_accelerometer.
 */
/**
 * @defgroup iface_wl_webos_accelerometer The wl_webos_accelerometer interface
 *
 * This is an interface for accelerometer device.
 */
extern const struct wl_interface wl_webos_accelerometer_interface;
#endif

/**
 * @ingroup iface_wl_webos_input_manager
 * @struct wl_webos_input_manager_interface
 */
struct wl_webos_input_manager_interface {
	/**
	 * get webos seat
	 *
	 * Returns a webos_seat associated with the seat.
	 */
	void (*get_webos_seat)(struct wl_client *client,
			       struct wl_resource *resource,
			       uint32_t id,
			       struct wl_resource *seat);
	/**
	 * set cursor visibility
	 *
	 * Sets the cursor visibility.
	 * @param visibility boolean for the cursor visibility
	 */
	void (*set_cursor_visibility)(struct wl_client *client,
				      struct wl_resource *resource,
				      uint32_t visibility);
};

#define WL_WEBOS_INPUT_MANAGER_CURSOR_VISIBILITY 0

/**
 * @ingroup iface_wl_webos_input_manager
 */
#define WL_WEBOS_INPUT_MANAGER_CURSOR_VISIBILITY_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_input_manager
 */
#define WL_WEBOS_INPUT_MANAGER_GET_WEBOS_SEAT_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_input_manager
 */
#define WL_WEBOS_INPUT_MANAGER_SET_CURSOR_VISIBILITY_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_input_manager
 * Sends an cursor_visibility event to the client owning the resource.
 * @param resource_ The client's resource
 * @param visibility boolean vaule for visibility of current cursor
 * @param webos_seat webos_seat cursor visibility changed, if this value is Null All cursors are hidden
 */
static inline void
wl_webos_input_manager_send_cursor_visibility(struct wl_resource *resource_, uint32_t visibility, struct wl_resource *webos_seat)
{
	wl_resource_post_event(resource_, WL_WEBOS_INPUT_MANAGER_CURSOR_VISIBILITY, visibility, webos_seat);
}

#ifndef WL_WEBOS_SEAT_CAPABILITY_ENUM
#define WL_WEBOS_SEAT_CAPABILITY_ENUM
/**
 * @ingroup iface_wl_webos_seat
 * webos seat capability bitmask
 *
 * This is a bitmask of capabilities this webOS seat has; if a member is
 * set, then it is present on the seat.
 */
enum wl_webos_seat_capability {
	/**
	 * this seat does not provide additional input
	 */
	WL_WEBOS_SEAT_CAPABILITY_DEFAULT = 0,
	/**
	 * this seat can provide gyroscope data, wl_webos_gyroscope
	 */
	WL_WEBOS_SEAT_CAPABILITY_GYROSCOPE = 1,
	/**
	 * this seat can provide accelerometer data, wl_webos_accelerometer
	 */
	WL_WEBOS_SEAT_CAPABILITY_ACCELEROMETER = 2,
};
#endif /* WL_WEBOS_SEAT_CAPABILITY_ENUM */

/**
 * @ingroup iface_wl_webos_seat
 * @struct wl_webos_seat_interface
 */
struct wl_webos_seat_interface {
	/**
	 * get interface for gyroscope
	 *
	 * If the seat has gyroscope sensor, user can get this interface.
	 */
	void (*get_gyroscope)(struct wl_client *client,
			      struct wl_resource *resource,
			      uint32_t id);
	/**
	 * get interface for accelerometer
	 *
	 * If the seat has accelerometer sensor, user can get this
	 * interface.
	 */
	void (*get_accelerometer)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t id);
};

#define WL_WEBOS_SEAT_INFO 0

/**
 * @ingroup iface_wl_webos_seat
 */
#define WL_WEBOS_SEAT_INFO_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_seat
 */
#define WL_WEBOS_SEAT_GET_GYROSCOPE_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_seat
 */
#define WL_WEBOS_SEAT_GET_ACCELEROMETER_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_seat
 * Sends an info event to the client owning the resource.
 * @param resource_ The client's resource
 * @param id an unique identifier for the seat
 * @param name a human readable name for the seat
 * @param designator a value for the designation of this seat
 */
static inline void
wl_webos_seat_send_info(struct wl_resource *resource_, uint32_t id, const char *name, uint32_t designator, uint32_t capabilities)
{
	wl_resource_post_event(resource_, WL_WEBOS_SEAT_INFO, id, name, designator, capabilities);
}

/**
 * @ingroup iface_wl_webos_gyroscope
 * @struct wl_webos_gyroscope_interface
 */
struct wl_webos_gyroscope_interface {
	/**
	 * request sensor data
	 *
	 * Requests to enable/disable sending data for gyroscope device.
	 * @param enabled boolean to indicate if sensor data is needed
	 */
	void (*request_data)(struct wl_client *client,
			     struct wl_resource *resource,
			     uint32_t enabled);
};

#define WL_WEBOS_GYROSCOPE_SENSOR_DATA 0

/**
 * @ingroup iface_wl_webos_gyroscope
 */
#define WL_WEBOS_GYROSCOPE_SENSOR_DATA_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_gyroscope
 */
#define WL_WEBOS_GYROSCOPE_REQUEST_DATA_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_gyroscope
 * Sends an sensor_data event to the client owning the resource.
 * @param resource_ The client's resource
 * @param x data for x-axis
 * @param y data for y-axis
 * @param z data for z-axis
 */
static inline void
wl_webos_gyroscope_send_sensor_data(struct wl_resource *resource_, wl_fixed_t x, wl_fixed_t y, wl_fixed_t z)
{
	wl_resource_post_event(resource_, WL_WEBOS_GYROSCOPE_SENSOR_DATA, x, y, z);
}

/**
 * @ingroup iface_wl_webos_accelerometer
 * @struct wl_webos_accelerometer_interface
 */
struct wl_webos_accelerometer_interface {
	/**
	 * request sensor data
	 *
	 * Requests to enable/disable sending data for accelerometer
	 * device.
	 * @param enabled boolean to indicate if sensor data is needed
	 */
	void (*request_data)(struct wl_client *client,
			     struct wl_resource *resource,
			     uint32_t enabled);
};

#define WL_WEBOS_ACCELEROMETER_SENSOR_DATA 0

/**
 * @ingroup iface_wl_webos_accelerometer
 */
#define WL_WEBOS_ACCELEROMETER_SENSOR_DATA_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_accelerometer
 */
#define WL_WEBOS_ACCELEROMETER_REQUEST_DATA_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_accelerometer
 * Sends an sensor_data event to the client owning the resource.
 * @param resource_ The client's resource
 * @param x data for x-axis
 * @param y data for y-axis
 * @param z data for z-axis
 */
static inline void
wl_webos_accelerometer_send_sensor_data(struct wl_resource *resource_, wl_fixed_t x, wl_fixed_t y, wl_fixed_t z)
{
	wl_resource_post_event(resource_, WL_WEBOS_ACCELEROMETER_SENSOR_DATA, x, y, z);
}

#ifdef  __cplusplus
}
#endif

#endif
