/* Generated by wayland-scanner 1.20.0 */

#ifndef WEBOS_SHELL_SERVER_PROTOCOL_H
#define WEBOS_SHELL_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_webos_shell The webos_shell protocol
 * @section page_ifaces_webos_shell Interfaces
 * - @subpage page_iface_wl_webos_shell - interface for webOS shell
 * - @subpage page_iface_wl_webos_shell_surface - interface to handle webos shell surfaces
 * @section page_copyright_webos_shell Copyright
 * <pre>
 *
 * Copyright (c) 2013-2020 LG Electronics, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 * </pre>
 */
struct wl_surface;
struct wl_webos_shell;
struct wl_webos_shell_surface;

#ifndef WL_WEBOS_SHELL_INTERFACE
#define WL_WEBOS_SHELL_INTERFACE
/**
 * @page page_iface_wl_webos_shell wl_webos_shell
 * @section page_iface_wl_webos_shell_desc Description
 *
 * This interface provides handlings on webOS shell surfaces.
 * @section page_iface_wl_webos_shell_api API
 * See @ref iface_wl_webos_shell.
 */
/**
 * @defgroup iface_wl_webos_shell The wl_webos_shell interface
 *
 * This interface provides handlings on webOS shell surfaces.
 */
extern const struct wl_interface wl_webos_shell_interface;
#endif
#ifndef WL_WEBOS_SHELL_SURFACE_INTERFACE
#define WL_WEBOS_SHELL_SURFACE_INTERFACE
/**
 * @page page_iface_wl_webos_shell_surface wl_webos_shell_surface
 * @section page_iface_wl_webos_shell_surface_desc Description
 *
 * This allows the client to associate an normal surface with a
 * shell surface. The shell surface provides webOS specific functionality
 * to surfaces.
 * @section page_iface_wl_webos_shell_surface_api API
 * See @ref iface_wl_webos_shell_surface.
 */
/**
 * @defgroup iface_wl_webos_shell_surface The wl_webos_shell_surface interface
 *
 * This allows the client to associate an normal surface with a
 * shell surface. The shell surface provides webOS specific functionality
 * to surfaces.
 */
extern const struct wl_interface wl_webos_shell_surface_interface;
#endif

/**
 * @ingroup iface_wl_webos_shell
 * @struct wl_webos_shell_interface
 */
struct wl_webos_shell_interface {
	/**
	 * deprecated request.
	 *
	 * This request is deprecated. If you want to create a new
	 * request, you can reuse this one. FYI, in that case, you also
	 * need to modify get_system_pip method in luna-surfacemanager as
	 * well.
	 */
	void (*get_system_pip)(struct wl_client *client,
			       struct wl_resource *resource);
	/**
	 * get a webOS shell surface
	 *
	 * Creates an webOS shell surface for an existing surface.
	 */
	void (*get_shell_surface)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t id,
				  struct wl_resource *surface);
};


/**
 * @ingroup iface_wl_webos_shell
 */
#define WL_WEBOS_SHELL_GET_SYSTEM_PIP_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell
 */
#define WL_WEBOS_SHELL_GET_SHELL_SURFACE_SINCE_VERSION 1

#ifndef WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_ENUM
#define WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_ENUM
/**
 * @ingroup iface_wl_webos_shell_surface
 * location mask for the surface
 *
 * Using this mask the surface can be positioned onto
 * different locations on screen. By not using absolute
 * coordinates we can create greater flexibility in the
 * compositor and the clients.
 */
enum wl_webos_shell_surface_location_hint {
	WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_NORTH = 1,
	WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_WEST = 2,
	WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_SOUTH = 4,
	WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_EAST = 8,
	WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_CENTER = 16,
};
#endif /* WL_WEBOS_SHELL_SURFACE_LOCATION_HINT_ENUM */

#ifndef WL_WEBOS_SHELL_SURFACE_STATE_ENUM
#define WL_WEBOS_SHELL_SURFACE_STATE_ENUM
/**
 * @ingroup iface_wl_webos_shell_surface
 * the state of the surface
 *
 * The state provides info to the client on how the compositor has placed
 * the surface.
 *
 * The default state will indicate to the client that it is windowed. The
 * "position_changed" event will tell the position in screen coordinates
 * when the surface is in this state.
 */
enum wl_webos_shell_surface_state {
	WL_WEBOS_SHELL_SURFACE_STATE_DEFAULT = 0,
	WL_WEBOS_SHELL_SURFACE_STATE_MINIMIZED = 1,
	WL_WEBOS_SHELL_SURFACE_STATE_MAXIMIZED = 2,
	WL_WEBOS_SHELL_SURFACE_STATE_FULLSCREEN = 3,
};
#endif /* WL_WEBOS_SHELL_SURFACE_STATE_ENUM */

#ifndef WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_ENUM
#define WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_ENUM
/**
 * @ingroup iface_wl_webos_shell_surface
 * the key that the surface handles
 *
 * The client uses wl_webos_shell_surface.set_key_mask to notify server
 * that it will handle specific keys only.
 */
enum wl_webos_shell_surface_webos_key {
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_HOME = 1,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_BACK = 2,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_EXIT = 4,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_NAVIGATION_LEFT = 8,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_NAVIGATION_RIGHT = 16,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_NAVIGATION_UP = 32,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_NAVIGATION_DOWN = 64,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_NAVIGATION_OK = 128,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_NUMERIC_KEYS = 256,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_COLOR_RED = 512,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_COLOR_GREEN = 1024,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_COLOR_YELLOW = 2048,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_COLOR_BLUE = 4096,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_PROGRAMME_GROUP = 8192,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_PLAYBACK_GROUP = 16384,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_TELETEXT_GROUP = 32768,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_LOCAL_LEFT = 65536,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_LOCAL_RIGHT = 131072,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_LOCAL_UP = 262144,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_LOCAL_DOWN = 524288,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_LOCAL_OK = 1048576,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_REMOTE_MAGNIFIER_GROUP = 2097152,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_MINIMAL_PLAYBACK_GROUP = 4194304,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_GUIDE = 8388608,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_TELETEXT_ACTIVE_GROUP = 16777216,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_DATA = 33554432,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_INFO = 67108864,
	WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_DEFAULT = 0xFFFFFFF8,
};
#endif /* WL_WEBOS_SHELL_SURFACE_WEBOS_KEY_ENUM */

#ifndef WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_ENUM
#define WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_ENUM
/**
 * @ingroup iface_wl_webos_shell_surface
 * the status of the add-on
 *
 * Status of the add-on for the given shell surface.
 * null: neither server-side add-on set nor loaded
 * loaded: the server-side add-on is loaded and visible
 * denied: the server-side add-on is not allowed to load
 * error: the server-side add-on is not loaded due to an error
 */
enum wl_webos_shell_surface_addon_status {
	WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_NULL = 0,
	WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_LOADED = 1,
	WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_DENIED = 2,
	WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_ERROR = 3,
};
#endif /* WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_ENUM */

/**
 * @ingroup iface_wl_webos_shell_surface
 * @struct wl_webos_shell_surface_interface
 */
struct wl_webos_shell_surface_interface {
	/**
	 * sets the preferred location hint
	 *
	 * The location hint is a guideline to the compositor where to
	 * place the surface. The compositor will do its best to place it
	 * there, however this is not guaranteed. Currently The location
	 * hint is only applied to _WEBOS_WINDOW_TYPE_POPUP and
	 * _WEBOS_WINDOW_TYPE_SYSTEM_UI surfaces.
	 */
	void (*set_location_hint)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t hint);
	/**
	 * sets the surface state
	 *
	 * The client requests its surface state to the compositor.
	 */
	void (*set_state)(struct wl_client *client,
			  struct wl_resource *resource,
			  uint32_t state);
	/**
	 * sets the surface property
	 *
	 * The client sets the surface property to the compositor. The
	 * property is given by a string pair (name, value).
	 */
	void (*set_property)(struct wl_client *client,
			     struct wl_resource *resource,
			     const char *name,
			     const char *value);
	/**
	 * sets the key mask for this surface
	 *
	 * A value of '1' in the mask indicates that the respective key
	 * event (both press and release) will be delivered to the client.
	 * Bitwise XOR operation against the default mask value and a
	 * supported individual values will result in that key not being
	 * delivered to the client. Notice that the default value omits
	 * certain keys.
	 *
	 * The compositor is free to ignore certain keys even if set to '1'
	 * depending on the overall system UI behaviour, most commonly this
	 * will mean the HOME key.
	 *
	 * NOTE: This protocol will eventually replace the string property
	 * based key filtering.
	 */
	void (*set_key_mask)(struct wl_client *client,
			     struct wl_resource *resource,
			     uint32_t webos_key);
	/**
	 * set the server-side add-on
	 *
	 * Sets the path to the server-side add-on. The compositor loads
	 * the add-on on receiving this request if the add-on is identified
	 * as a valid one.
	 * @since 2
	 */
	void (*set_addon)(struct wl_client *client,
			  struct wl_resource *resource,
			  const char *path);
	/**
	 * reset the server-side add-on
	 *
	 * Requests to unload the add-on if it is loaded. If there is no
	 * add-on loaded this request is silently ignored.
	 * @since 2
	 */
	void (*reset_addon)(struct wl_client *client,
			    struct wl_resource *resource);
};

#define WL_WEBOS_SHELL_SURFACE_STATE_CHANGED 0
#define WL_WEBOS_SHELL_SURFACE_POSITION_CHANGED 1
#define WL_WEBOS_SHELL_SURFACE_CLOSE 2
#define WL_WEBOS_SHELL_SURFACE_EXPOSED 3
#define WL_WEBOS_SHELL_SURFACE_STATE_ABOUT_TO_CHANGE 4
#define WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_CHANGED 5

/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_STATE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_POSITION_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_CLOSE_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_EXPOSED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_STATE_ABOUT_TO_CHANGE_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_CHANGED_SINCE_VERSION 2

/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_SET_LOCATION_HINT_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_SET_STATE_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_SET_PROPERTY_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_SET_KEY_MASK_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_SET_ADDON_SINCE_VERSION 2
/**
 * @ingroup iface_wl_webos_shell_surface
 */
#define WL_WEBOS_SHELL_SURFACE_RESET_ADDON_SINCE_VERSION 2

/**
 * @ingroup iface_wl_webos_shell_surface
 * Sends an state_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_shell_surface_send_state_changed(struct wl_resource *resource_, uint32_t state)
{
	wl_resource_post_event(resource_, WL_WEBOS_SHELL_SURFACE_STATE_CHANGED, state);
}

/**
 * @ingroup iface_wl_webos_shell_surface
 * Sends an position_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_shell_surface_send_position_changed(struct wl_resource *resource_, int32_t x, int32_t y)
{
	wl_resource_post_event(resource_, WL_WEBOS_SHELL_SURFACE_POSITION_CHANGED, x, y);
}

/**
 * @ingroup iface_wl_webos_shell_surface
 * Sends an close event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_shell_surface_send_close(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, WL_WEBOS_SHELL_SURFACE_CLOSE);
}

/**
 * @ingroup iface_wl_webos_shell_surface
 * Sends an exposed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_shell_surface_send_exposed(struct wl_resource *resource_, struct wl_array *rectangles)
{
	wl_resource_post_event(resource_, WL_WEBOS_SHELL_SURFACE_EXPOSED, rectangles);
}

/**
 * @ingroup iface_wl_webos_shell_surface
 * Sends an state_about_to_change event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_shell_surface_send_state_about_to_change(struct wl_resource *resource_, uint32_t state)
{
	wl_resource_post_event(resource_, WL_WEBOS_SHELL_SURFACE_STATE_ABOUT_TO_CHANGE, state);
}

/**
 * @ingroup iface_wl_webos_shell_surface
 * Sends an addon_status_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_shell_surface_send_addon_status_changed(struct wl_resource *resource_, uint32_t addon_status)
{
	wl_resource_post_event(resource_, WL_WEBOS_SHELL_SURFACE_ADDON_STATUS_CHANGED, addon_status);
}

#ifdef  __cplusplus
}
#endif

#endif
