/* Generated by wayland-scanner 1.20.0 */

#ifndef WEBOS_SYSTEM_UX_SERVER_PROTOCOL_H
#define WEBOS_SYSTEM_UX_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_webos_system_ux The webos_system_ux protocol
 * @section page_ifaces_webos_system_ux Interfaces
 * - @subpage page_iface_wl_webos_system_ux - api to open sustem ui apps
 * @section page_copyright_webos_system_ux Copyright
 * <pre>
 *
 * Copyright (c) 2023 LG Electronics, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * </pre>
 */
struct wl_webos_system_ux;

#ifndef WL_WEBOS_SYSTEM_UX_INTERFACE
#define WL_WEBOS_SYSTEM_UX_INTERFACE
/**
 * @page page_iface_wl_webos_system_ux wl_webos_system_ux
 * @section page_iface_wl_webos_system_ux_desc Description
 * @section page_iface_wl_webos_system_ux_api API
 * See @ref iface_wl_webos_system_ux.
 */
/**
 * @defgroup iface_wl_webos_system_ux The wl_webos_system_ux interface
 */
extern const struct wl_interface wl_webos_system_ux_interface;
#endif

/**
 * @ingroup iface_wl_webos_system_ux
 * @struct wl_webos_system_ux_interface
 */
struct wl_webos_system_ux_interface {
	/**
	 * report opened state of the system ux
	 *
	 * 
	 * @param app app name of system ux
	 */
	void (*opened)(struct wl_client *client,
		       struct wl_resource *resource,
		       const char *app);
	/**
	 * report closed state of the system ux
	 *
	 * 
	 * @param app app name of system ux
	 */
	void (*closed)(struct wl_client *client,
		       struct wl_resource *resource,
		       const char *app);
	/**
	 * request focus
	 *
	 * 
	 */
	void (*request_focus)(struct wl_client *client,
			      struct wl_resource *resource,
			      const char *name);
	/**
	 * release focus
	 *
	 * 
	 */
	void (*release_focus)(struct wl_client *client,
			      struct wl_resource *resource,
			      const char *name);
	/**
	 * invoke general request of the system ux
	 *
	 * 
	 * @param action name of request action
	 * @param windowType name of system ux window type
	 * @param params request data of system ux app
	 */
	void (*invoke)(struct wl_client *client,
		       struct wl_resource *resource,
		       const char *action,
		       const char *windowType,
		       const char *params);
};

#define WL_WEBOS_SYSTEM_UX_OPEN 0
#define WL_WEBOS_SYSTEM_UX_CLOSE 1
#define WL_WEBOS_SYSTEM_UX_NOTIFY 2

/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_OPEN_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_CLOSE_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_NOTIFY_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_OPENED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_CLOSED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_REQUEST_FOCUS_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_RELEASE_FOCUS_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_system_ux
 */
#define WL_WEBOS_SYSTEM_UX_INVOKE_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_system_ux
 * Sends an open event to the client owning the resource.
 * @param resource_ The client's resource
 * @param app name of system ux app
 * @param windowType name of system ux window type
 * @param params parameter of system ux app
 */
static inline void
wl_webos_system_ux_send_open(struct wl_resource *resource_, const char *app, const char *windowType, const char *params)
{
	wl_resource_post_event(resource_, WL_WEBOS_SYSTEM_UX_OPEN, app, windowType, params);
}

/**
 * @ingroup iface_wl_webos_system_ux
 * Sends an close event to the client owning the resource.
 * @param resource_ The client's resource
 * @param app name of system ux app
 */
static inline void
wl_webos_system_ux_send_close(struct wl_resource *resource_, const char *app)
{
	wl_resource_post_event(resource_, WL_WEBOS_SYSTEM_UX_CLOSE, app);
}

/**
 * @ingroup iface_wl_webos_system_ux
 * Sends an notify event to the client owning the resource.
 * @param resource_ The client's resource
 * @param action name of event action
 * @param windowType name of system ux window type
 * @param params event data of system ux app
 */
static inline void
wl_webos_system_ux_send_notify(struct wl_resource *resource_, const char *action, const char *windowType, const char *params)
{
	wl_resource_post_event(resource_, WL_WEBOS_SYSTEM_UX_NOTIFY, action, windowType, params);
}

#ifdef  __cplusplus
}
#endif

#endif
